#include "card_c.h"

unsigned char cc_karta[7];
const unsigned char tablica[] = { 0x22, 0x59, 0x7D, 0xEA };

//------------------------------
// jedyne funcje exportowe
//------------------------------

void Koduj(t_karta k);
void Dekoduj(t_karta *k);

//------------------------------
// wszystko co potrzeba do generacji karty
//------------------------------

unsigned char dzielnik;
unsigned char taxvalue;
unsigned char typ;
unsigned int seria;
unsigned int seryjny;
unsigned char k796c;
unsigned char k796d;

void Sprawdz_pop_czyt()
{
 unsigned char l,r,x;

 x=(cc_karta[0] & 0xc3) | 0x28;

 for(int i=1; i<8; i++)
  x^=cc_karta[i];

 l=(cc_karta[0] & 0x3c) >> 2;
 r=(x ^ (x >> 4));
 r=(~r) & 0x0f;

 if (l!=r)
 {
  cc_karta[0]=cc_karta[0] & 0xc3;
  cc_karta[0]=cc_karta[0] | (r >> 2);
 }
}


void Zamiana()
{
  asm{
  xor ax,ax
  xor bx,bx
  mov al, byte ptr cc_karta
  mov bl, byte ptr cc_karta+1

  mov cl,al
  and cl,0x0f
  mov ch,bl
  shl ch,4
  or cl,ch

  and al,0xf0
  shr bl,4
  or al,bl

  mov dl, byte ptr cc_karta+2
  mov byte ptr cc_karta, dl
  mov dl, byte ptr cc_karta+3
  mov byte ptr cc_karta+1, dl
  mov dl, byte ptr cc_karta+4
  mov byte ptr cc_karta+2, dl

  mov byte ptr cc_karta+3, al
  mov byte ptr cc_karta+4, cl
  }
}

void MiszMasz()
{
 int X, k7DB9, k7DBE;
 char temp;

 k7DB9=0x19;
 X=4;
 do
 {
  k7DBE=X;
  asm{
   xor ax,ax
   mov bx,X
   dec bx
   mov al,byte ptr cc_karta[bx]
   rcr al,1
   mov bx,0
   pushf
  }
petla1:
  asm{
   mov al,byte ptr cc_karta[bx]
   popf
   rcr al,1
   pushf
   mov byte ptr cc_karta[bx],al
   inc bx
   cmp bx, k7DBE
   jb petla1
   popf
  }
  X=k7DBE;
  asm{
   xor ax,ax
   mov bx,X
   mov al,byte ptr cc_karta[bx]
   rcl al,1
   mov bx,7
   pushf
  }
petla2:
  asm{
   mov al,byte ptr cc_karta[bx]
   popf
   rcl al,1
   pushf
   mov byte ptr cc_karta[bx],al
   dec bx
   cmp bx, k7DBE
   jae petla2
   popf
  }
  k7DB9--;
  if (k7DB9==0) break;
  X=k7DBE;
  X--;
  if (X<=0) X=7;
 } while(1);
}

void A579(char b)
{
  asm{
  xor ax,ax
  xor bx,bx
  mov bl,b
  mov cx,8
  }
petla:
  asm{
  mov al,bl
  xor al,k796d
  rcr al,1
  jnc dalej
  mov al,8
  xor k796c,al
  mov al,16
  xor k796d,al
  stc
  }
dalej:
  asm{
  rcr k796c,1
  rcr k796d,1
  shr bx,1
  dec cx
  jne petla
  }
}

void sprawdz()
{
 char temp;

 k796c=0xEE;
 asm{
  mov ah,byte ptr cc_karta[3]
  mov al,byte ptr cc_karta[4]
  shl ax,1
  and ah,3
  xor bx,bx
  mov bl,ah
  mov al,byte ptr tablica[bx]
  mov k796d,al
 }
 temp=cc_karta[0];
 A579(temp);
 temp=cc_karta[1];
 A579(temp);
 asm{
  mov ax,seria
  shr ax,2
  mov temp,al
 }
 A579(temp);
 asm{
  mov ah,byte ptr seria
  mov al,byte ptr cc_karta[2]
  shr ax,2
  mov temp,al
 }
 A579(temp);
 asm{
  xor ax,ax
  mov al,byte ptr cc_karta[5]
  shl ax,3
  mov bl,dzielnik
  and bx,7
  or al,bl
  mov temp,al
 }
 A579(temp);
 asm{
  xor ax,ax
  mov al,typ
  shl al,1
  xor bx,bx
  mov bl,byte ptr cc_karta[3]
  and bl,1
  or al,bl
  shl al,1
  mov bl,byte ptr cc_karta[4]
  shl bx,1
  or al,bh
  shl al,4
  mov bl,6
  or al,bl
  mov temp,al
 }
 A579(temp);
}

void extract()
{
  asm{
  mov al, byte ptr cc_karta[3]
  rcl al,4
  and al,3
  mov typ,al

  mov al,byte ptr cc_karta[3]
  shl al,1
  mov al,byte ptr cc_karta[2]
  rcl al,1
  and al,7
  mov dzielnik,al

  xor ax,ax
  mov al,byte ptr cc_karta[2]
  shr ax,2
  and al,1
  mov taxvalue,al

  xor ax,ax
  mov al,byte ptr cc_karta[4]
  shl ax,3
  and ah,3
  mov bx,ax
  mov al,byte ptr cc_karta[5]
  shl ax,3
  and ah,7
  or bl,ah
  mov seria,bx

  xor ax,ax
  mov ah,byte ptr cc_karta[0]
  mov al,byte ptr cc_karta[1]
  mov seryjny,ax
  }
}

void codein()
{
  asm{
  mov al, typ
  shl al,5
  or byte ptr cc_karta[3],al

  mov al,dzielnik
  and al,1
  shl al,7
  or byte ptr cc_karta[3],al
  mov al,dzielnik
  shr al,1
  or byte ptr cc_karta[2],al

  mov al,taxvalue
  shl al,2
  or byte ptr cc_karta[2],al

  mov ax,seria
  shl ax,5
  or byte ptr cc_karta[4],ah
  or byte ptr cc_karta[5],al

  mov ax,seryjny
  mov byte ptr cc_karta[0],ah
  mov byte ptr cc_karta[1],al
  }
}

void Koduj(t_karta k)
{
 cc_karta[0]=0;
 cc_karta[1]=0;
 cc_karta[2]=0;
 cc_karta[3]=0;
 cc_karta[4]=0;
 cc_karta[5]=0;
 cc_karta[6]=0;
 cc_karta[7]=0;

 typ=k.typ;
 dzielnik=k.dzielnik;
 taxvalue=k.taxvalue;
 seria=k.seria;
 seryjny=k.seryjny;

 codein();
 sprawdz();
 cc_karta[6]=k796c;
 cc_karta[7]=k796d;

 for(int i=0;i<173;i++)
    MiszMasz();
 for(i=0;i<20;i++)
    Zamiana();

 Sprawdz_pop_czyt();
}

void Dekoduj(t_karta *k)
{
 Zamiana();
 MiszMasz();
 extract();
 k->typ=typ;
 k->dzielnik=dzielnik;
 k->taxvalue=taxvalue;
 k->seria=seria;
 k->seryjny=seryjny;
}
