{
  rozpiska bitow:
  D0, D1, D2, D3 - sterowanie silnika krokowego, 1 podawana na kolejne
  D4 - uklad formujacy - sygnal wysoki
  D5 - uklad formujacy - sygnal bardzo wysoki (ok. 130 mA) do kasowania
  D6 - uklad formujacy - sygnal niski
  D7 - do czujki
  ONOFF - od czujki
}

uses crt,card_c;

const
step_masks:array[0..3] of byte = (1,2,4,8);

var
card:t_karta;
pierwsze:boolean;
c:char;
i:integer;
ilbitow,ilimpulsow:integer;
last_pos:integer;
karta:array[0..7] of byte;
bity:array[0..400] of byte;

{===========================================================================
 procki i/o z naszym urzadzeniem - krok, podanie 0 i 1
 ===========================================================================}

procedure krok1(dir:shortint);
var
b:byte;
begin
 b:=port[$378];
 b:=b and $0f0;
 if (dir>0) then
  last_pos:=last_pos+1
 else
  last_pos:=last_pos+3;
 last_pos:=last_pos mod 4;
 b:=b or step_masks[last_pos];
 port[$378]:=b;
 delay(10);
end;

procedure krok2(dir:shortint);
var
b:byte;
begin
 b:=port[$378];
 b:=b and $0f0;
 if (dir>0) then
  last_pos:=last_pos+1
 else
  last_pos:=last_pos+3;
 last_pos:=last_pos mod 4;
 b:=b or step_masks[last_pos];
 port[$378]:=b;
 delay(10);
end;


procedure glWylacz;
begin
 delay(10);
 port[$378]:=port[$378] and $00f;
 delay(10);
end;

procedure glBWysoki;
var
b:byte;
begin
 delay(10);
 b:=port[$378];
 b:=b and $00f;
 b:=b or (16+64);
 port[$378]:=b;
 delay(10);
end;

procedure glWysoki;
var
b:byte;
begin
 delay(10);
 b:=port[$378];
 b:=b and $00f;
 b:=b or 16;
 port[$378]:=b;
 delay(10);
end;

procedure glNiski;
var
b:byte;
begin
 delay(10);
 b:=port[$378];
 b:=b and $00f;
 b:=b or 64;
 port[$378]:=b;
 delay(10);
end;

procedure Daj0;
begin
 glWylacz;
 krok1(-1);
 krok1(-1);
 glWysoki;
 krok1(-1);       {0 jest oki}
 krok1(-1);
 glWylacz;
 krok1(-1);
 krok1(-1);
end;


procedure Daj1;
begin
 glWylacz;
 krok1(-1);
 krok1(-1);
 glWylacz;
 glWysoki;
 krok1(-1);
 glWylacz;
 glNiski;
 krok1(-1);
 krok1(-1);
 krok1(-1);
 glWylacz;
end;

{===========================================================================
 procki obslugi karty
 ===========================================================================}

procedure InitKarty;
begin
 writeln('Podaj typ karty : ');
 writeln('[I]mpulsowa');
 writeln('[M]aintenance');
 writeln('[P]rogramming');
 writeln('[S]ample');
 writeln('[T]est');
 writeln('[V]BLProgramming');
 case upcase(readkey) of
      'I':card.typ:=2;
      'M':begin
           card.typ:=0;
           card.seria:=1;
          end;
      'P':begin
           card.typ:=1;
           card.seria:=1;
          end;
      'S':begin
           card.typ:=1;
           card.seria:=2;
          end;
      'T':begin
           card.typ:=1;
           card.seria:=3;
          end;
      'V':begin
           card.typ:=1;
           card.seria:=4;
          end;
   end;
 write('Podaj dzielnik [1 (/1), 2 (/2), 3 (/4), 4 (/5), 5(/8), 6(/10), 7(/20)]: ');
 readln(card.dzielnik);
 write('Podaj taxvalue [0,1] : ');
 readln(card.taxvalue);
 if (card.typ=2) then
 begin
  write('Podaj serie karty [0-1023] : ');
  readln(card.seria);
 end;
 write('Podaj nr seryjny karty [0-65535] : ');
 readln(card.seryjny);
 write('Podaj ilosc impulsow [1-255] : ');
 readln(ilimpulsow);

 Koduj(card);
 karta[0]:=cc_karta[0];
 karta[1]:=cc_karta[1];
 karta[2]:=cc_karta[2];
 karta[3]:=cc_karta[3];
 karta[4]:=cc_karta[4];
 karta[5]:=cc_karta[5];
 karta[6]:=cc_karta[6];
 karta[7]:=cc_karta[7];
end;

procedure NaBity;
var
i,j:integer;
maska:byte;
begin
   ilBitow:=0;

   Bity[ilBitow]:=1;                  { sekcja 1 - 11ABCD0 }
   inc(ilBitow);
   Bity[ilBitow]:=1;
   inc(ilBitow);
   for i:=0 to 3 do
   begin
      maska:=128;
      for j:=0 to 7 do
      begin
         if ((Karta[i] and maska)<>0) then
            Bity[ilBitow]:=1
         else
            Bity[ilBitow]:=0;
         inc(ilbitow);
         maska:=maska shr 1;
      end;
   end;
   Bity[ilBitow]:=0;
   inc(ilbitow);

   Bity[ilBitow]:=253;                   { samotne 0 posrodku}
   inc(ilbitow);
   Bity[ilBitow]:=0;
   inc(ilbitow);
   Bity[ilBitow]:=254;
   inc(ilbitow);

   for i:=4 to 7 do                      { sekcja 2 - EFGH0 }
   begin
      maska:=128;
      for j:=0 to 7 do
      begin
         if ((Karta[i] and maska)<>0) then
            Bity[ilBitow]:=1
         else
            Bity[ilBitow]:=0;
         inc(ilbitow);
         maska:=maska shr 1;
      end;
   end;
   Bity[ilBitow]:=0;
   inc(ilbitow);

   Bity[ilBitow]:=255;                    { impulsy - 001111...110}
   inc(ilbitow);
   Bity[ilBitow]:=0;
   inc(ilbitow);
   Bity[ilBitow]:=0;
   inc(ilbitow);
   for i:=1 to ilimpulsow do
   begin
      Bity[ilBitow]:=1;
      inc(ilbitow);
   end;
   Bity[ilBitow]:=0;
end;

procedure PodawajImpulsy;
var
i:integer;
j:integer;
begin
 for i:=0 to ilbitow do
 begin
  gotoxy(1,5);
  writeln(((i*100.0)/ilbitow):3:3,'%');
  if i<4 then
   pierwsze:=true
  else
   pierwsze:=false;
  case bity[i] of
           0:begin
              gotoxy(1+(i mod 72),6+(i div 72));
              write('0');
              Daj0;
             end;
           1:begin
              gotoxy(1+(i mod 72),6+(i div 72));
              write('1');
              Daj1;
             end;
           2:begin
              gotoxy(1+(i mod 72),6+(i div 72));
              write('-');
              port[$378]:=port[$378] and $00f;
              for j:=0 to 5 do
               krok2(-1);
             end;
         253:begin
              port[$378]:=port[$378] and $00f;
              for j:=0 to 65 do
               krok2(-1);
             end;
         254:begin
              port[$378]:=port[$378] and $00f;
              for j:=0 to 89 do
               krok2(-1);
             end;
         255:begin
              port[$378]:=port[$378] and $00f;
              for j:=0 to 41 do
               krok2(-1);
             end;
      end;
 end;
 writeln;
end;

procedure Nagrywaj;
begin
 clrscr;
 port[$378]:=0;
 InitKarty;
 NaBity;
 clrscr;
 writeln('Zmien polaryzacje glowicy na nagrywanie');
 readkey;
 writeln('WLOZ KARTE :)');
 repeat until ((port[$379] and 16)=0);
 repeat krok2(-1) until ((port[$379] and 16)=16);
 writeln('Poczekaj, az karta ustawi sie przed glowica...');
 for i:=0 to 539 do
 begin
  port[$378]:=port[$378] and $00f;
  krok2(-1);
 end;
 for i:=0 to 299 do
 begin
  port[$378]:=port[$378] and $00f;
  krok2(-1);
 end;
 writeln('Zaczynamy...');
 port[$378]:=port[$378] and $00f;
 PodawajImpulsy;
 port[$378]:=0;
 writeln('Nagrywanie zakonczone. Trwa wysuwanie karty');
 for i:=0 to ((ilbitow*6)+1500) do
  krok2(1);
 writeln('Odbierz karte i klepnij [ENTER]');
 readln;
end;


procedure Kasuj;
begin
 clrscr;
 port[$378]:=0;
 writeln('Zmien polaryzacje glowicy na kasowanie');
 readkey;
 writeln('WLOZ KARTE :)');
 repeat until ((port[$379] and 16)=0);
 repeat krok2(-1) until ((port[$379] and 16)=16);
 writeln('Poczekaj, az karta ustawi sie przed glowica...');
 for i:=0 to 349 do
  krok2(-1);
 writeln('Zaczynamy...');
 port[$378]:=port[$378] or 32;
 for i:=0 to 2799 do
 begin
  krok2(-1);
  gotoxy(1,5);
  writeln((i/2799*100):3:3,'%');
 end;
 port[$378]:=0;
 writeln('Kasowanie zakonczone. Trwa wysuwanie karty');
 for i:=0 to 3849 do
  krok2(1);
 writeln('Odbierz karte i klepnij [ENTER]');
 readln;
end;


begin
 port[$378]:=0;
 last_pos:=0;
 repeat
  clrscr;
  writeln('Program obslugi nagrywarki');
  writeln('1. Nagrywamy');
  writeln('2. Kasujemy');
  writeln('3. Wychodzimy');
  c:=readkey;
  case (c) of
        '1':Nagrywaj;
        '2':Kasuj;
   end;
 until c='3';
 port[$378]:=0;
end.
